import { world, ItemStack } from "@minecraft/server"
import { showForm } from "./ui"

world.afterEvents.entityDie.subscribe(ev => {

    let dropChance = 0.04

    if (ev.damageSource.damagingEntity?.typeId == "minecraft:player") {
        let mainhand = ev.damageSource.damagingEntity.getComponent("equippable").getEquipment("Mainhand")
        if (mainhand.hasComponent("enchantable") && mainhand.getComponent("enchantable").hasEnchantment("looting")) {
            let enchant = mainhand.getComponent("enchantable").getEnchantment("looting")
            dropChance += 0.02 * enchant.level
        };
    };

    if (Math.random() <= dropChance) {
        try {
            let killedMobType = ev.deadEntity.typeId
            let killDimension = ev.deadEntity.dimension
            let killPosition = ev.deadEntity.location
            killDimension.spawnItem(new ItemStack("essence_foundry:" + killedMobType.split(":")[1] + "_essence", 1), killPosition)
        }
        catch { return }
    }
})

let spawnerMined = false
let spawnerLocation = null

world.beforeEvents.playerBreakBlock.subscribe(ev => {
    if (ev.block.typeId == "minecraft:mob_spawner") {
        spawnerLocation = ev.block.location
        spawnerMined = true
    }
})

world.afterEvents.playerBreakBlock.subscribe(ev => {
    if (ev.block.typeId == "minecraft:air"
        && spawnerLocation != null
        && ev.block.location.x == spawnerLocation.x
        && ev.block.location.y == spawnerLocation.y
        && ev.block.location.z == spawnerLocation.z) {
        ev.dimension.spawnItem(new ItemStack("essence_foundry:cage_panel", 8), ev.block.location)
        spawnerMined = false
        spawnerLocation = null
    }
})

world.afterEvents.itemUse.subscribe(ev => {
    if (ev.itemStack.typeId == "essence_foundry:essence_foundry_guide_book") showForm(ev.source, "Main Menu")
})