import { ActionFormData } from "@minecraft/server-ui"

let ui_pages = {
    "Main Menu": new ActionFormData()
        .title("Essence Foundry")
        .body("\nWelcome to Essence Foundry! This addon allows you collect essence from mobs and use them to craft spawn eggs and spawners.\n\nIf you ever lose this book, it can be crafted with any essence and a book.\n\n")
        .button("Main Menu")
        .button("Collecting Essence")
        .button("Crafting")
        .button("Notes"),

    "Collecting Essence": new ActionFormData()
        .title("Collecting Essence")
        .body("\nEach mob has a chance to drop it's respective essence. There is a 4 percent chance of an essence dropping from a mob by default. This increases by 2 percent per level of looting up to a maximum of 10 percent.\n\n")
        .button("Main Menu")
        .button("Collecting Essence")
        .button("Crafting")
        .button("Notes"),

    "Crafting": new ActionFormData()
        .title("Crafting")
        .body("\n§5Ender Paste §fis a core ingredient needed to craft spawn eggs and spawners. It is made by combining §b1 §9Blaze Powder§f, §b1 §9Ender Pearl§f, and §b1 §9Bottle of Water §fin the crafting table (shapeless recipe).\n\n§5Spawn Eggs §fare crafted in a crafting table with §b1 §9Eye of Ender §fin the middle, §b4 §9Ender Paste §fon the sides, and §b4 §9Essence §fof the desired mob in the corners.\n\n§5Crying Rods §fare made by placing §9Crying Obsidian §fin a blast furnace.\n\n§5Cage Panels §fare used to craft spawners. §b6 §9Crying Rods §fin the top and bottom rows and §b3 §9Ender Paste §fin the middle row gives §b4 §9Cage Panels§f.\n\nA §5Spawner §fcan be made with §b1 §9Dragon's Breath §fin the middle and §b8 §9Cage Panels §fsurrounding it.\n\n")
        .button("Main Menu")
        .button("Collecting Essence")
        .button("Crafting")
        .button("Notes"),

    "Notes": new ActionFormData()
        .title("Notes")
        .body("\nGet a looting sword as fast as you can. It will increase your chance of a mob dropping it's essence.\n\nRight click an empty spawner with a spawn egg to set the mob that it will spawn.\n\nBreaking a spawner will drop the Cage Panels but you will still need a Dragon's Breath to rebuild it and a spawn egg to set the mob.\n\nPlanned features include an essence pouch to keep all the essences from clogging up your inventory and various scepters that will allow you to spawn mobs to fight for you as well as other cool abilities.\n\n")
        .button("Main Menu")
        .button("Collecting Essence")
        .button("Crafting")
        .button("Notes")
}

export function showForm(player, page) {
    let form = ui_pages[page]
    form.show(player).then(res => {
        if (res.canceled) return
        switch (res.selection) {
            case 0: showForm(player, "Main Menu"); break
            case 1: showForm(player, "Collecting Essence"); break
            case 2: showForm(player, "Crafting"); break
            case 3: showForm(player, "Notes"); break
        }
    })
}